#ifndef NSQL_H
#define NSQL_H

class SSTREAM;


#ifndef _mysql_h
	class MYSQL_RES;
#endif

class NSQL_ARGS{
public:
	char *server;
	char *db;
	/*~PROTOBEG~ NSQL_ARGS */
public:
	NSQL_ARGS (const char *_server, const char *_db);
	NSQL_ARGS (void);
	int isok (void);
	void setdb (const char *s);
	void setserver (const char *s);
	~NSQL_ARGS (void);
	/*~PROTOEND~ NSQL_ARGS */
};


#include <stdarg.h>

class NSQL_INTERNAL;

class NSQL{
	NSQL_INTERNAL *internal;
	/*~PROTOBEG~ NSQL */
public:
	NSQL (NSQL_ARGS&args);
	NSQL (SSTREAM *sout);
	NSQL (const char *server, const char *db);
	int a_query (const char *req);
	int a_queryf (const char *ctl, ...);
	int a_vqueryf (const char *ctl, va_list list);
	int connect (void);
	int disconnect (void);
	const char *error (void);
	void free_result (MYSQL_RES *res);
	int query (const char *req);
	int queryf (const char *ctl, ...);
	MYSQL_RES *store_result (void);
	int vqueryf (const char *ctl, va_list list);
	~NSQL (void);
	/*~PROTOEND~ NSQL */
};
class SSTRING;
class SSTRINGS;

class NSQL_ENCODE{
	SSTRINGS *tb;
	/*~PROTOBEG~ NSQL_ENCODE */
public:
	NSQL_ENCODE (void);
	const char *enc (const SSTRING&s);
	const char *enc (const char *s);
	~NSQL_ENCODE (void);
	/*~PROTOEND~ NSQL_ENCODE */
};

#endif

